Bug 476704 - [QLogic 4.8 bug] qla2xxx - Properly support programmable devices
[QLogic 4.8 bug] qla2xxx - Properly support programmable devices
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.8
All Linux
high Severity high
: beta
: 4.8
Assigned To: Marcus Barrow
Martin Jenner
: OtherQA
: 495107 (view as bug list)
Depends On:
Blocks: 450896 RHEL4u8_relnotes
  Show dependency treegraph
 
Reported: 2008-12-16 11:35 EST by Marcus Barrow
Modified: 2009-06-20 04:59 EDT (History)
11 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-18 15:20:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
flash fix 1 (4.10 KB, patch)
2009-01-06 23:22 EST, Marcus Barrow
no flags Details | Diff
flash fix part 2 (2.61 KB, patch)
2009-01-06 23:23 EST, Marcus Barrow
no flags Details | Diff
flash fix part 3 (25.66 KB, patch)
2009-01-06 23:23 EST, Marcus Barrow
no flags Details | Diff
qla2xxx - remove /sysfs nvram entries (4.21 KB, patch)
2009-04-02 12:06 EDT, Marcus Barrow
no flags Details | Diff

  None (edit)
Description Marcus Barrow 2008-12-16 11:35:36 EST
Problems have been reported by QLogic and customers properly supporting the Flash and NVram devices on qla2xxx HBA's.
Comment 1 Marcus Barrow 2009-01-06 23:22:31 EST
Created attachment 328340 [details]
flash fix 1
Comment 2 Marcus Barrow 2009-01-06 23:23:06 EST
Created attachment 328341 [details]
flash fix part 2
Comment 3 Marcus Barrow 2009-01-06 23:23:38 EST
Created attachment 328342 [details]
flash fix part 3
Comment 4 Marcus Barrow 2009-01-06 23:25:32 EST
part 1 patch:

 - The switch statement entry for QLA_25XX was missing in the option rom
   table routine.

 - The switch statement for handling SST flash was missing the sector size
   for device type "8e", correct flash masks.

 - Fix an undefined ref in a debug printk.


part 2 patch:
Some flash parts have a slow enable write-protection (WP)
operation whereby subsequent FLASH accesses would fail if the WP
operation had not completed.  Software now polls the SPI's
status-register for WP completion.


part 3 patch:
- Missing case label for ISP2522,2512.
- Add many calls to schedule to prevent machine freeze.
- missing header file and other fixes for debugging.
Comment 5 RHEL Product and Program Management 2009-01-09 13:50:03 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 7 Vivek Goyal 2009-01-15 09:05:19 EST
Committed in 78.29.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 8 Vivek Goyal 2009-01-23 15:22:55 EST
This was a patch series of 3 patches. Marcus found that third patch caused some power machines to be unbootable. Hence backing out third patch till the issue is fixed.

Putting the bz back to POST state so that I can revert the patch.
Comment 9 Vivek Goyal 2009-01-26 10:37:35 EST
Reverted Third patch of the series. "qla2xxx: more fix flash for isp25xx and scheduling"

Reverted back in 80.EL. RPMs are available at 

http://people.redhat.com/vgoyal/rhel4/
Comment 11 Chris Ward 2009-03-13 10:04:22 EDT
~~ Attention Partners!  ~~
RHEL 4.8Beta has been released on partners.redhat.com. There should
be a fix present, which addresses this bug. Please test and report back results on this OtherQA Partner bug at your earliest convenience.

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe any issues you encountered. If you have found a NEW bug, clone this bug and describe the issues you've encountered. Further questions can be directed to your Red Hat Partner Manager.

If you have VERIFIED the bug fix. Please select your PartnerID from the Verified field above. Please leave a comment with your test results details. Include which arches tested, package version and any applicable logs.

 - Red Hat QE Partner Management
Comment 12 Richard A Lary 2009-03-17 13:37:53 EDT
Installed public beta on IBM p6 server with HBA Model QLE2562 dual port adapter.
qla2xxx version 8.02.09.00.04.08-d, kernel  2.6.9-82.EL

Using scli version v1.7.1 Build 23 I successfully updated adapter flash using multiflash image Q25AF201.BIN.

I verified that this driver was capable of updating flash on QLE2562 adapter,
thus completing IBM's verification of fix for this issue.

It should be noted, there was an issue with the qioctlmod v1.0.03 included in the scli flash utility (v1.7.1 Build 23) used. ioctlmod is not distributed by Red Hat. The issue has been reported to QLogic.  For the record, flash update completed successfully, however, debug call traces were logged to the console as a result of qioctlmod:
Debug: sleeping function called from invalid context at mm/slab.c:2063
in_atomic():0[expected: 0], irqs_disabled():1
Call Trace:
[c0000001dc39b6d0] [c00000000005da28] .__might_sleep+0xcc/0xec (unreliable)
[c0000001dc39b770] [c0000000000a1cf8] .kmem_cache_alloc+0x40/0xc0
[c0000001dc39b800] [c0000000000b5f18] .__get_vm_area+0x110/0x268
[c0000001dc39b8b0] [c0000000000b638c] .__vmalloc+0x5c/0x1a4
[c0000001dc39b970] [d0000000018217e4] .qim_write_vpd_nv_data+0x50/0xdc [qioctlmod]
[c0000001dc39ba20] [d000000001821f10] .qim_update_vpd+0x18c/0x210 [qioctlmod]
[c0000001dc39baf0] [d00000000181557c] .qim_send_ioctl+0x6d4/0x7f0 [qioctlmod]
[c0000001dc39bbb0] [d00000000181469c] .qim_ioctl+0x1c/0x30 [qioctlmod]
[c0000001dc39bc30] [c0000000000e0284] .sys_ioctl+0x36c/0x3ec
[c0000001dc39bcf0] [d000000001825648] .qim2xxx_ioctl32+0x10/0x28 [qioctlmod]
[c0000001dc39bd70] [c0000000000ff338] .compat_sys_ioctl+0x1e4/0x454
[c0000001dc39be30] [c000000000011280] syscall_exit+0x0/0x18
Comment 14 Marcus Barrow 2009-04-02 12:06:11 EDT
Created attachment 337840 [details]
qla2xxx - remove /sysfs nvram entries
Comment 15 Marcus Barrow 2009-04-02 12:11:22 EDT
In this patch set the third one was reverted because of issues found in QLogic testing. That work was later submitted as a part of BZ 491784, basically a batch of late updates.

An additional fix has been found required for a locking panic on UP machines in the /sysfs entries for NVRAM. This last patch removes those entries as they are not intended to be supported by this driver. That information is provided by a separate ioctl module.
Comment 16 Vivek Goyal 2009-04-04 16:10:08 EDT
Committed in 87.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 18 Nate Straz 2009-04-09 16:01:27 EDT
*** Bug 495107 has been marked as a duplicate of this bug. ***
Comment 19 Chris Ward 2009-04-16 09:13:44 EDT
~~ Attention! Snap 4 Released ~~
RHEL 4.8 Snapshot 4 has been released on partners.redhat.com. There
should be a fix present that resolves this bug. There's not much more time to test. Please report back results ASAP.

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. If you have found a NEW bug, clone this
bug and describe the issues you encountered. Further questions can be
directed to your Red Hat Partner Manager.

If you have VERIFIED the bug fix. Please select your PartnerID from the
Verified field above. Please leave a comment with your test results details.
Include which arches tested, package version and any applicable logs.
Comment 21 errata-xmlrpc 2009-05-18 15:20:33 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html

Note You need to log in before you can comment on or make changes to this bug.